Index: /branches/rsr.v5.1.dev/web/app/data/data.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/data.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/data.php	(revision 1)
@@ -0,0 +1,69 @@
+<?php
+
+  class data
+  {
+    public $env;
+    public $sql;
+    public $modules;
+
+    public $parent;
+
+    function __construct($sql, $env, $parent = null)
+    { $this->env = $env;
+      $this->sql = $sql;
+      $this->modules = array();
+      $this->parent = $parent;
+    }
+
+    function load($file_path)
+    { if($file_path && file_exists($file_path))
+      { $v_path = explode("/", $file_path);
+        $file = $v_path[count($v_path) - 1];
+        if(strcasecmp(substr($file, -4), ".php") == 0)
+        { $class_name = substr($file, 0, -4);
+          require_once $file_path;
+          if(class_exists($class_name) && !$this->modules[$class_name])
+          { $this->modules[$class_name] = new $class_name($this->sql, $this->env, $this);
+          }
+        }
+      }
+    }
+
+    function load_modules($modules_path, $recursif = false)
+    { if($dh = opendir($modules_path))
+      { while(($file = readdir($dh)) !== false)
+        { if(is_dir($modules_path.$file))
+          { if($recursif && substr($file, 0, 1) != ".") $this->load_modules($modules_path.$file."/", $recursif);
+          }
+          elseif(strcasecmp(substr($file, -4), ".php") == 0) $this->load($modules_path.$file);
+        }
+        closedir($dh);
+      }
+    }
+
+    function __call($method_name, $arguments)
+    { $root = $this;
+      while(isset($root->parent)) $root = $root->parent;
+      return $this->data_call($root, $method_name, $arguments);
+    }
+
+    function data_call($data_impl, $method_name, $arguments)
+    { $r = false;
+      $args = "";
+      foreach($arguments as $i => $arg) $args .= ($args ? ", " : "")."\$arguments[".$i."]";
+      foreach($data_impl->modules as $module_name => $module)
+      { if(method_exists($module, $method_name))
+        { eval("\$r = \$module->".$method_name."(".$args.");");
+          break;
+        }
+        else
+        { $r = $this->data_call($module, $method_name, $arguments);
+          if($r !== false) break;
+        }
+      }
+      return $r;
+    }
+
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_albums.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_albums.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_albums.php	(revision 1)
@@ -0,0 +1,161 @@
+<?php
+
+  class da_albums extends data
+  {
+
+    function artiste_albums($id_artiste, $actif = null)
+    { $albums = array();
+      try
+      { $sql = "SELECT * FROM #--albums WHERE id_artiste=".$this->eq($id_artiste);
+        if(isset($actif)) $sql .= " AND actif=".($actif ? "1" : "0");
+        $sql .= " ORDER BY ordre ASC";
+        $rst = $this->sql->query($sql);
+        while($v_rst = $this->sql->fetch_assoc($rst)) $albums[$v_rst["id"]] = $v_rst;
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $albums = false; }
+      return $albums;
+    }
+
+    /**
+
+      $max === null : la requete recupere tous les resultats
+      $max === true : la requete recupere $this->env->config("max_list") resultats
+      $max === n : la requete recupere n resultats
+
+    **/
+
+    function albums($start = 0, $max = null, $order_by = null, $order = null, $WHERE = "")
+    { $albums = array();
+      try
+      { $sql =
+         "SELECT #--albums.*, #--artistes.nom as artiste, #--artistes.id as id_artiste FROM #--albums, #--artistes"
+        ." WHERE #--albums.id_artiste=#--artistes.id"
+        .($WHERE ? " AND ".$WHERE : "")
+        .(isset($order_by) ? " ORDER BY ".$order_by.(isset($order) ? " ".$order: "") : "")
+        .( isset($max) ?
+             ( $max === true ?
+                 ($this->env->config("max_list") ? " LIMIT ".$start.",".$this->env->config("max_list") : "")
+               : " LIMIT ".$start.",".$max
+             )
+           : ""
+         );
+        $rst = $this->sql->query($sql);
+        while($v_rst = $this->sql->fetch_assoc($rst)) $albums[$v_rst["id"]] = $v_rst;
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $albums = false; }
+      return $albums;
+    }
+
+    function set_artiste_albums($id_artiste, $ordre, $actif)
+    { if(($albums = $this->artiste_albums($id_artiste)) !== false)
+      { try
+        { foreach($albums as $id => $album)
+          { $query =
+             "UPDATE #--albums SET"
+            ."  ordre=".$ordre[$id]
+            .", actif=".($actif[$id] ? 1 : 0)
+            ." WHERE id=".$id;
+            $this->sql->query($query);
+          }
+        }
+        catch(Exception $_e) { return false; }
+      }
+      return true;
+    }
+
+    function artiste_album($id)
+    { $album = array();
+      try
+      { $sql = "SELECT * FROM #--albums WHERE id=".$this->eq($id);
+        $rst = $this->sql->query($sql);
+        if($v_rst = $this->sql->fetch_assoc($rst)) $album = $v_rst;
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $album = false; }
+      return $album;
+    }
+
+    function add_artiste_album($id_artiste, $titre, $image, $description, $url, $format, $taille, $date_creation)
+    { $id_album;
+      try
+      { $sql =
+         "INSERT INTO #--albums"
+        ."( id_artiste"
+        .", titre"
+        .", image"
+        .", description"
+        .", url"
+        .", format"
+        .", taille"
+        .", date_creation"
+        .", date_publication"
+        .", compteur"
+        .", actif"
+        .") VALUES"
+        ."( ".$this->eq($id_artiste)
+        .", ".$this->eq($titre)
+        .", ".$this->eq($image)
+        .", ".$this->eq($description)
+        .", ".$this->eq($url)
+        .", ".$this->eq($format)
+        .", ".$this->eq($taille)
+        .", ".$this->eq($date_creation)
+        .", NOW()"
+        .", 0"
+        .", 1"
+        .")";
+        $this->sql->query($sql);
+        $id_album = $this->sql->insert_id();
+      }
+      catch(Exception $_e) { $id_album = false; }
+      return $id_album;
+    }
+
+    function set_artiste_album($id, $titre, $image, $description, $url, $format, $taille, $date_creation)
+    { try
+      { $sql =
+         "UPDATE #--albums SET"
+        ."  titre=".$this->eq($titre)
+        .", image=".$this->eq($image)
+        .", description=".$this->eq($description)
+        .", url=".$this->eq($url)
+        .", format=".$this->eq($format)
+        .", taille=".$this->eq($taille)
+        .", date_creation=".$this->eq($date_creation)
+        ." WHERE id=".$this->eq($id);
+        $this->sql->query($sql);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function del_artiste_album($id)
+    { try
+      { $sql = "DELETE FROM #--albums WHERE id=".$this->eq($id);
+        $this->sql->query($sql);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function inc_album_compteur($id_album)
+    { $url = false;
+      try
+      { $sql = "SELECT url FROM #--albums WHERE id=".$id_album;
+        $rst = $this->sql->query($sql);
+        if($v_rst = $this->sql->fetch_assoc($rst)) $url = $v_rst["url"];
+        if($url);
+        { $sql =
+           "UPDATE #--albums SET compteur=(compteur + 1) WHERE id=".$id_album; 
+          $this->sql->query($sql);
+        }
+      }
+      catch(Exception $_e) { $url = false; }
+      return $url;
+    }
+
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_artistes.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_artistes.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_artistes.php	(revision 1)
@@ -0,0 +1,226 @@
+<?php
+
+  class da_artistes extends data
+  {
+
+    function artistes_au_hasard($max = null, $get_size = false)
+    { $ARTISTES = array();
+      $IMG_WIDTH  = 60;
+      $IMG_HEIGHT = 60;
+      try
+      { $query =
+         "SELECT id, nom, style, image"
+        ." FROM #--artistes"
+        ." ORDER BY RAND()"
+        .(isset($max) ? " LIMIT ".$max : "");
+        $rst = $this->sql->query($query);
+        $artistes = array();
+        $i = 0;
+        while($v_rst = $this->sql->fetch_assoc($rst))
+        { $ARTISTES[$i] = Array();
+          $ARTISTES[$i]["id"]   = $v_rst["id"];
+          $ARTISTES[$i]["nom"]   = $v_rst["nom"];
+          $ARTISTES[$i]["style"] = $v_rst["style"];
+          $width = $IMG_WIDTH;
+          $height = $IMG_HEIGHT;
+          $EXISTS = true;
+          if($get_size)
+          { list($width, $height, $type, $attr) = @getimagesize($v_rst["image"]);
+            $EXISTS = false;
+            if($width) $EXISTS = true;
+            if($EXISTS)
+            { $div = 1;
+              if(($width / $div) > $IMG_WIDTH) $div = $width / $IMG_WIDTH;
+              if(($height / $div) > $IMG_HEIGHT) $div = $height / $IMG_HEIGHT;
+              $width = floor($width / $div);
+              $height = floor($height / $div);
+            }
+            else
+            { $width = $IMG_WIDTH;
+              $height = $IMG_HEIGHT;
+            }
+          }
+          $ARTISTES[$i]["image"] = Array();
+          $ARTISTES[$i]["image"]["src"] = $EXISTS ? $v_rst["image"] : "";
+          $ARTISTES[$i]["image"]["width"] = $width;
+          $ARTISTES[$i]["image"]["height"] = $height;
+          $i++;
+        }
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $artistes = false; }
+      return $ARTISTES;
+    }
+
+    function artistes($pun_user = null)
+    { $artistes = array();
+      try
+      { $query =
+         "SELECT * FROM #--artistes"
+        .(isset($pun_user) ? " WHERE pun_user=".$pun_user : "")
+        ." ORDER BY nom";
+        $rst = $this->sql->query($query);
+        $artistes = array();
+        while($v_rst = $this->sql->fetch_assoc($rst)) { $artistes[$v_rst["id"]] = $v_rst; }
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $artistes = false; }
+      return $artistes;
+    }
+
+    function artiste($id)
+    { $artiste = array();
+      try
+      { $query =
+         "SELECT *"
+        ." FROM #--artistes"
+        ." WHERE ".$this->env->bdd["prefix"]."artistes.id=".$id;
+        $rst = $this->sql->query($query);
+        if($v_rst = $this->sql->fetch_assoc($rst)) $artiste = $v_rst;
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $artiste = false; }
+      return $artiste;
+    }
+
+    function artiste_presentation($id)
+    { $presentation = "";
+      try
+      { $query =
+         "SELECT presentation"
+        ." FROM #--artistes"
+        ." WHERE id=".$id;
+        $rst = $this->sql->query($query);
+        if($v_rst = $this->sql->fetch_assoc($rst)) $presentation = $v_rst["presentation"];
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $presentation = false; }
+      return $presentation;
+    }
+
+    function set_artiste_presentation($id, $presentation)
+    { try
+      { $query =
+         "UPDATE #--artistes"
+        ." SET presentation=".$this->eq($presentation)
+        ." WHERE id=".$id;
+        $this->sql->query($query);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function add_artiste($pun_user, $nom, $forum = null, $dossier_personnel = null)
+    { try
+      { $sql =
+         "INSERT INTO #--artistes(nom, pun_user, pun_forum, dossier_personnel) VALUES"
+        ."( ".$this->eq($nom)
+        .", ".$pun_user
+        .", ".$this->eq($forum)
+        .", ".$this->eq($dossier_personnel)
+        .")";
+        $this->sql->query($sql);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function admin_set_artiste($id, $nom, $forum = null, $dossier_personnel = null)
+    { try
+      { $query =
+         "UPDATE #--artistes SET"
+        ."  nom=".$this->eq($nom)
+        .", pun_forum=".$this->eq($forum)
+        .", dossier_personnel=".$this->eq($dossier_personnel)
+        ." WHERE id=".$id;
+        $this->sql->query($query);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function set_artiste
+    ( $id,
+      $nom,
+      $image,
+      $style,
+      $pays,
+      $site,
+      $email_contact,
+      $hide_email,
+      $contact_form,
+      $identifiant_paypal,
+      $lien_boutique,
+      $lien_facebook,
+      $lien_flickr,
+      $lien_twitter,
+      $lien_youtube,
+      $dossier_personnel = null
+    )
+    { try
+      { $query =
+         "UPDATE #--artistes SET"
+        ."  nom=".$this->eq($nom)
+        .", image=".$this->eq($image)
+        .", style=".$this->eq($style)
+        .", pays=".$this->eq($pays)
+        .", site=".$this->eq($site)
+        .", email_contact=".$this->eq($email_contact)
+        .", hide_email=".$hide_email
+        .", contact_form=".$contact_form
+        .", identifiant_paypal=".$this->eq($identifiant_paypal)
+        .", lien_boutique=".$this->eq($lien_boutique)
+        .", lien_facebook=".$this->eq($lien_facebook)
+        .", lien_flickr=".$this->eq($lien_flickr)
+        .", lien_twitter=".$this->eq($lien_twitter)
+        .", lien_youtube=".$this->eq($lien_youtube)
+        .", dossier_personnel=".$this->eq($dossier_personnel)
+        ." WHERE id=".$id;
+        $this->sql->query($query);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function del_artiste($id_artiste)
+    { try
+      { if(($id_artiste_news_categorie = $this->id_categorie(array("root", "artistes", "news", $id_artiste))) !== false)
+        { if($id_artiste_news_categorie)
+          { $sql =
+             "DELETE FROM #--contenus"
+            ." WHERE categorie=".$id_artiste_news_categorie;
+            $this->sql->query($sql);
+            $sql = "DELETE FROM #--categories WHERE id=".$id_artiste_news_categorie;
+            $this->sql->query($sql);
+            $sql = "DELETE FROM #--categories_tree WHERE child=".$id_artiste_news_categorie;
+            $this->sql->query($sql);
+          }
+        }
+        else return false;
+        $sql = "DELETE FROM #--albums WHERE id_artiste=".$this->eq($id_artiste);
+        $this->sql->query($sql);
+        $sql = "DELETE FROM #--concerts WHERE id_artiste=".$this->eq($id_artiste);
+        $this->sql->query($sql);
+        $sql = "DELETE FROM #--videos WHERE id_artiste=".$this->eq($id_artiste);
+        $this->sql->query($sql);
+        $downloads = array();
+        $sql = "SELECT id FROM #--downloads WHERE id_artiste=".$this->eq($id_artiste);
+        $rst = $this->sql->query($sql);
+        while($v_rst = $this->sql->fetch_assoc($rst)) $downloads[] = $v_rst["id"];
+        $this->sql->free_result($rst);
+        foreach($downloads as $id_download)
+        { $sql = "DELETE FROM #--download_urls WHERE id_download=".$id_download; 
+          $this->sql->query($sql);
+          $sql = "DELETE FROM #--downloads WHERE id=".$id_download;
+          $this->sql->query($sql);
+        }
+        $sql = "DELETE FROM #--artistes WHERE id=".$this->eq($id_artiste);
+        $this->sql->query($sql);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_downloads.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_downloads.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_downloads.php	(revision 1)
@@ -0,0 +1,284 @@
+<?php
+
+  class da_downloads extends data
+  {
+
+    function artiste_downloads($id = null, $public = false, $album = null, $_sql = null)
+    { $downloads = array();
+      try
+      { $query =
+         "SELECT #--downloads.*"
+        .", #--artistes.nom as auteur"
+        .", #--licences.nom as licence"
+        .", #--licences.lien as licence_url"
+        ." FROM #--artistes"
+        .", #--downloads"
+        .", #--licences"
+        ." WHERE #--downloads.id_artiste=#--artistes.id"
+        .(isset($id) ? " AND #--artistes.id=".$id : "")
+        ." AND #--downloads.id_licence=#--licences.id"
+        .($public ? " AND actif=1" : "")
+        .(isset($album) ? " AND id_album=".$album : "")
+        .(isset($_sql) ? $_sql : " ORDER BY #--downloads.ordre ASC");
+        $rst = $this->sql->query($query);
+        while($v_rst = $this->sql->fetch_assoc($rst))
+        { $downloads[$v_rst["id"]] = $v_rst;
+          $downloads[$v_rst["id"]]["compteur"] = 0;
+          $downloads[$v_rst["id"]]["urls"] = array();
+          $u_query =
+           "SELECT #--download_urls.*, #--formats.nom as format"
+          ." FROM #--download_urls, #--formats"
+          ." WHERE id_download=".$v_rst["id"]
+          ." AND #--download_urls.id_format=#--formats.id";
+          $u_rst = $this->sql->query($u_query);
+          while($v_u_rst = $this->sql->fetch_assoc($u_rst))
+          { $downloads[$v_rst["id"]]["urls"][$v_u_rst["id"]] = $v_u_rst;
+            $downloads[$v_rst["id"]]["compteur"] += $v_u_rst["compteur"];
+            if($v_u_rst["format"] === "mp3")
+            { $downloads[$v_rst["id"]]["mp3_id_url"] = $v_u_rst["id"];
+              $downloads[$v_rst["id"]]["mp3_url"] = $v_u_rst["url"];
+            }
+          }
+          $this->sql->free_result($u_rst);
+        }
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $downloads = false; }
+      return $downloads;
+    }
+
+    function nb_downloads($public = false)
+    { $n = 0;
+      try
+      { $select =
+         "SELECT count(*) as n"
+        ." FROM #--downloads";
+        $where = $public ? " WHERE actif=1 AND id_licence IS NOT NULL" : "";
+        $rst = $this->sql->query($select.$where);
+        if($v_rst = $this->sql->fetch_assoc($rst)) $n = $v_rst["n"];
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $n = false; }
+      return $n;
+    }
+
+    function nb_mp3($id, $public = false, $album = null)
+    { $n = 0;
+      try
+      { $query =
+         "SELECT #--downloads.id"
+        ." FROM #--artistes, #--downloads"
+        ." WHERE #--downloads.id_artiste=#--artistes.id"
+        ." AND #--artistes.id=".$id
+        .($public ? " AND actif=1 AND id_licence IS NOT NULL" : "")
+        .(isset($album) ? " AND id_album=".$album : "");
+        $rst = $this->sql->query($query);
+        while($v_rst = $this->sql->fetch_assoc($rst))
+        { $u_query =
+           "SELECT count(*) as n"
+          ." FROM #--download_urls, #--formats"
+          ." WHERE id_download=".$v_rst["id"]
+          ." AND #--download_urls.id_format=#--formats.id"
+          ." AND #--formats.nom='mp3'";
+          $u_rst = $this->sql->query($u_query);
+          if($v_u_rst = $this->sql->fetch_assoc($u_rst)) $n += $v_u_rst["n"];
+          $this->sql->free_result($u_rst);
+        }
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $n = false; }
+      return $n;
+    }
+
+    function artiste_download($id)
+    { $download = array();
+      try
+      { $query =
+         "SELECT #--downloads.*"
+        .", #--licences.nom as licence"
+        .", #--licences.lien as licence_url"
+        ." FROM #--downloads, #--licences"
+        ." WHERE #--downloads.id=".$id
+        ." AND #--downloads.id_licence=#--licences.id";
+        $rst = $this->sql->query($query);
+        if($v_rst = $this->sql->fetch_assoc($rst))
+        { $download = $v_rst;
+          $download["urls"] = array();
+          $u_query =
+           "SELECT #--download_urls.*, #--formats.nom as format"
+          ." FROM #--download_urls, #--formats"
+          ." WHERE id_download=".$v_rst["id"]
+          ." AND #--download_urls.id_format=#--formats.id";
+          $u_rst = $this->sql->query($u_query);
+          while($v_u_rst = $this->sql->fetch_assoc($u_rst))
+          { $download["urls"][$v_u_rst["id"]] = $v_u_rst;
+            if($v_u_rst["format"] === "mp3") $download["mp3_url"] = $v_u_rst["url"];
+          }
+          $this->sql->free_result($u_rst);
+        }
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $download = false; }
+      return $download;
+    }
+
+    function licences()
+    { $licences = array();
+      try
+      { $query = "SELECT * FROM #--licences";
+        $rst = $this->sql->query($query);
+        while($v_rst = $this->sql->fetch_assoc($rst)) $licences[$v_rst["id"]] = $v_rst;
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $licences = false; }
+      return $licences;
+    }
+
+    function formats()
+    { $formats = array();
+      try
+      { $query = "SELECT * FROM #--formats";
+        $rst = $this->sql->query($query);
+        while($v_rst = $this->sql->fetch_assoc($rst)) $formats[$v_rst["id"]] = $v_rst;
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $formats = false; }
+      return $formats;
+    }
+
+    function add_download($id_artiste, $nom, $album, $style, $id_licence, $date_creation, $id_format, $url)
+    { try
+      { $query =
+         "INSERT INTO #--downloads VALUES"
+        ."(NULL"
+        .", ".$id_artiste
+        .", ".$this->eq($album)
+        .", ".$id_licence
+        .", ".$this->eq($nom)
+        .", '".$date_creation."'"
+        .", ".$this->eq($style)
+        .", NULL"
+        .", 0"
+        .", 1"
+        .")";
+        $this->sql->query($query);
+        $id_download = $this->sql->insert_id();
+        $query =
+         "INSERT INTO #--download_urls VALUES"
+        ."(NULL"
+        .", ".$id_download
+        .", ".$id_format
+        .", NULL"
+        .", ".$this->eq($url)
+        .", NULL"
+        .", '".date("Y-m-d")."'"
+        .", 0"
+        .")";
+        $this->sql->query($query);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function set_download($id, $nom, $album, $style, $id_licence, $date_creation)
+    { try
+      { $query =
+         "UPDATE #--downloads SET"
+        ."  nom=".$this->eq($nom)
+        .", id_album=".$this->eq($album)
+        .", style=".$this->eq($style)
+        .", id_licence=".$id_licence
+        .", date_creation='".$date_creation."'"
+        ." WHERE id=".$id;
+        $this->sql->query($query);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function del_download($id_download)
+    { try
+      { $this->sql->query("DELETE FROM #--downloads WHERE id=".$this->eq($id_download));
+        $this->sql->query("DELETE FROM #--download_urls WHERE id_download=".$this->eq($id_download));
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function add_download_url($id_download, $url, $id_format)
+    { try
+      { $query =
+         "INSERT INTO #--download_urls(id_download, id_format, url, date_publication) VALUES"
+        ."( ".$id_download
+        .", ".$id_format
+        .", ".$this->eq($url)
+        .", '".date("Y-m-d")."'"
+        .")";
+        $this->sql->query($query);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function set_download_url($id_download_url, $url, $id_format)
+    { try
+      { $query =
+         "UPDATE #--download_urls SET"
+        ."  url=".$this->eq($url)
+        .", id_format=".$id_format
+        ." WHERE id=".$id_download_url;
+        $this->sql->query($query);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function del_download_url($id_download, $id_download_url)
+    { if(($download = $this->artiste_download($id_download)) !== false)
+      { try
+        { $this->sql->query("DELETE FROM #--download_urls WHERE id=".$this->eq($id_download_url));
+          if(count($download["urls"]) <= 1)
+          { if($this->del_download($id_download)) return 2;
+            else return false;
+          }
+        }
+        catch(Exception $_e) { return false; }
+      }
+      else return false;
+      return 1;
+    }
+
+    function set_downloads($ordre, $actif)
+    { try
+      { foreach($ordre as $id => $_ordre)
+        { $query =
+           "UPDATE #--downloads SET"
+          ."  ordre=".$_ordre
+          .", actif=".($actif[$id] ? 1 : 0)
+          ." WHERE id=".$id;
+          $this->sql->query($query);
+        }
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function inc_download_compteur($id_download)
+    { $url = false;
+      try
+      { $sql = "SELECT url FROM #--download_urls WHERE id=".$id_download;
+        $rst = $this->sql->query($sql);
+        if($v_rst = $this->sql->fetch_assoc($rst)) $url = $v_rst["url"];
+        if($url)
+        { $sql =
+           "UPDATE #--download_urls SET compteur=(compteur + 1) WHERE id=".$id_download; 
+          $this->sql->query($sql);
+        }
+      }
+      catch(Exception $_e) { $url = false; }
+      return $url;
+    }
+
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_news.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_news.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/artistes/da_news.php	(revision 1)
@@ -0,0 +1,51 @@
+<?php
+
+  class da_news extends data
+  {
+
+    function artiste_news($id_artiste, $start = 0, $public = false, $max = null, $id_contenu = null)
+    { if(isset($id_contenu))
+      { if(($contenu = $this->contenu($id_contenu)) !== false)
+        { return array
+          ( "total" => 1,
+            "list" => array($contenu["id"] => $contenu)
+          );
+        }
+        return false;
+      }
+      return $this->contenus
+      ( array("root", "artistes", "news", $id_artiste),
+        $start,
+        $max,
+        ($public ? " AND public=1 AND date_publication <= NOW()" : ""),
+        0
+      );
+    }
+
+    function add_artiste_news($id_artiste, $id_user, $titre, $contenu, $date_publication, $public)
+    { if(($id_categorie = $this->id_categorie(array("root", "artistes", "news", $id_artiste))) !== false)
+      { if(!isset($id_categorie))
+        { if(($id_artiste_news_root = $this->id_categorie(array("root", "artistes", "news"))) !== false)
+          { if(($id_categorie = $this->add_categorie($id_artiste, null, null, null, "", $id_artiste_news_root)) === false) return false;
+          }
+          else return false;
+        }
+        return $this->add_contenu(null, $id_categorie, $titre, "", $contenu, $id_user, $date_publication, $public);
+      }
+      return false;
+    }
+
+    function set_artiste_news($id_artiste, $id_user, $id, $titre, $contenu, $date_publication, $public)
+    { if(($id_categorie = $this->id_categorie(array("root", "artistes", "news", $id_artiste))) !== false)
+      { return $this->set_contenu($id, null, $id_categorie, $titre, "", $contenu, $id_user, $date_publication, $public);
+      }
+      return false;
+    }
+
+    function del_artiste_news($id)
+    { return $this->del_contenu($id);
+    }
+
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/data/modules/contenus/dc_editos.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/contenus/dc_editos.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/contenus/dc_editos.php	(revision 1)
@@ -0,0 +1,52 @@
+<?php
+
+  class dc_editos extends data
+  {
+
+    function editos($start = 0)
+    { return $this->contenus(array("editos"), $start);
+    }
+
+    function edito($id = null)
+    { if
+      ( ( $contenus = $this->contenus
+          ( array("editos"),
+            0,
+            1,
+            isset($id) ?
+              " AND #--contenus.id=".$this->eq($id)
+            : " AND public=1 AND date_publication <= NOW()"
+          )
+        ) !== false
+      )
+      { $edito = (($edito = current($contenus["list"])) !== false ? $edito : (isset($id) ? false : array()));
+        return $edito;
+      }
+      return false;
+    }
+
+    function add_edito($titre, $contenu, $auteur, $date_publication, $public)
+    { if(($id_categorie = $this->id_categorie(array("editos"))) !== false)
+      { if(isset($id_categorie))
+        { return $this->add_contenu("", $id_categorie, $titre, "", $contenu, $auteur, $date_publication, $public);
+        }
+      }
+      return false;
+    }
+
+    function set_edito($id, $titre, $contenu, $auteur, $date_publication, $public)
+    { if(($id_categorie = $this->id_categorie(array("editos"))) !== false)
+      { if(isset($id_categorie))
+        { return $this->set_contenu($id, "", $id_categorie, $titre, "", $contenu, $auteur, $date_publication, $public);
+        }
+      }
+      return false;
+    }
+
+    function del_edito($id)
+    { return $this->del_contenu($id);
+    }
+
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/data/modules/contenus/dc_links.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/contenus/dc_links.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/contenus/dc_links.php	(revision 1)
@@ -0,0 +1,48 @@
+<?php
+
+  class dc_links extends data
+  {
+
+    # ----------------------------------------------------------------------------------------
+    #                                                                               categories
+    #
+
+    function links_categories($path)
+    { return $this->categories($path);
+    }
+
+    function all_links($path = array())
+    { $_path = array("root", "links");
+      foreach($path as $__path) $_path[] = $__path;
+      if(($id = $this->id_categorie($_path)) !== false)
+      { return $this->sub_categories($id, null);
+      }
+      return false;
+    }
+
+    function links_categorie($id)
+    { return $this->categorie($id);
+    }
+
+    function add_links_categorie($nom, $titre, $description, $url = null, $parent = null)
+    { return $this->add_categorie
+      ( $nom,
+        $titre,
+        null,
+        $description,
+        $url,
+        isset($parent) ? $parent : $this->id_categorie(array("root", "menus"))
+      );
+    }
+
+    function set_links_categorie($id, $nom, $titre, $description, $url, $ordre = null)
+    { return $this->set_categorie($id, $nom, $titre, null, $description, $url, $ordre);
+    }
+
+    function del_links_categorie($id)
+    { return $this->del_categorie($id, true);
+    }
+
+  }
+
+?>
